/* TPI instructions */
#define TPI_SLD_POSTI 0x24 // 
#define TPI_SST_POSTI 0x64 // 
#define TPI_SETPR_LO  0x68 // 
#define TPI_SETPR_HI  0x69 // 
#define TPI_SIN       0x10 // 
#define TPI_SOUT      0x90 // 
#define TPI_SLDCS     0x80 // 
#define TPI_SSTCS     0xc0 // 
#define TPI_SKEY      0xe0 // 

/* tpiReadCS/tpiWriteCS addressing
 *
 * SLDCS/SSTCS : addr | 0x8000
 * SIN/SOUT    : addr
 */
#define TPI_CS_TPISR		0x8000
  #define TPI_CS_NVMEN			1
#define TPI_CS_TPIPCR		0x8002
  #define TPI_CS_IDLE_128		0
  #define TPI_CS_IDLE_64		1
  #define TPI_CS_IDLE_32		2
  #define TPI_CS_IDLE_16		3
  #define TPI_CS_IDLE_8			4
  #define TPI_CS_IDLE_4			5
  #define TPI_CS_IDLE_2			6
  #define TPI_CS_IDLE_0			7

#define TPI_CS_TPIIR		0x800f
  #define TPI_CS_ID_TPI			0x80

#define TPI_NVMCSR		0x32
  #define TPI_NVMBSY		  7
#define TPI_NVMCMD		0x33
  #define TPI_NVM_NOP		0x00
  #define TPI_NVM_CHIP_ERASE	0x10
  #define TPI_NVM_SECT_ERASE	0x14
  #define TPI_NVM_WRITE		0x1d

#define TPI_DS_SIGNATURE        0x3FC0
#define TPI_DS_LOCKBITS         0x3F00
#define TPI_DS_FUSE             0x3F40
#define TPI_DS_CALIB            0x3F80
#define TPI_DS_FLASH            0x4000

