#ifndef __aspconfig_h_included__
#define __aspconfig_h_included__

static inline void connect_led_on() {
    /* GREEN or YELLOW on */
    PORTB |= (1<< PB4);
    DDRB  |= (1<< PB4);
}

static inline void connect_led_off() {
    /* GREEN or YELLOW off */
    DDRB  &= ~(1<< PB4);
    PORTB &= ~(1<< PB4);
}

static inline void busy_led_on() {
    /* RED or ORANGE off : reversed */
    //DDRD  &= ~(1<< PD4);
    PORTD &= ~(1<< PD4);
    DDRD  |= (1<< PD4);
}

static inline void busy_led_off() {
    /* RED or ORANGE on : reversed */
    PORTD |= (1<< PD4);
    DDRD  |= (1<< PD4);
}

#define ENABLE_ISP1
#define ISP_OUT   PORTB
#define ISP_IN    PINB
#define ISP_DDR   DDRB
#define ISP_RST   PB0	/* SS */
#define ISP_MOSI  PB2	/* MOSI = ISP MOSI */
#define ISP_MISO  PB3	/* MISO = ISP MISO */
#define ISP_SCK   PB1	/* SCLK */

//#define ENABLE_ISP2
//#define ISP2_OUT   PORTB
//#define ISP2_IN    PINB
//#define ISP2_DDR   DDRB
//#define ISP2_RST   PB0
//#define ISP2_MOSI  PB2	/* MOSI = TX */
//#define ISP2_MISO  PB3	/* MISO = RX */
//#define ISP2_SCK   PB1	/* SCLK = XCK */
//#define ISP2_DIR   PB6	/* for buffer control - L: TX , H or Hi-Z: RX */

#define ENABLE_PDI
#define ENABLE_TPI
//#define ENABLE_HARD_PDITPI
#define ENABLE_SOFT_PDITPI

#define PDITPI_OUT   PORTB
#define PDITPI_IN    PINB
#define PDITPI_DDR   DDRB
#define PDITPI_RST   PB0
#define PDITPI_MOSI  PB2	/* MOSI = TX or DATA (in SOFT mode)*/
#define PDITPI_MISO  PB3	/* MISO = RX */
#define PDITPI_SCK   PB1	/* SCLK = XCK */
#define PDITPI_DIR   PB6	/* for buffer control - L: TX , H or Hi-Z: RX */

static inline void pditpi_dir_init() {
	PDITPI_DDR |= (1<< PDITPI_DIR);
	PDITPI_OUT &= ~(1<< PDITPI_DIR);
}

static inline void pditpi_dir_tx() {
	PDITPI_OUT &= ~(1<< PDITPI_DIR);
}

static inline void pditpi_dir_rx() {
	PDITPI_OUT |= (1<< PDITPI_DIR);
}

static inline int8_t pditpi_dir_is_tx() {
	return !(PDITPI_OUT & (1<< PDITPI_DIR));
}

static inline void tpi_reset(uchar is_assert) {
#ifdef PDITPI_RST
	if (is_assert) {
		PDITPI_DDR |=(1<< PDITPI_RST); // L 
	} else {
		PDITPI_DDR &= ~(1<< PDITPI_RST); // HI-Z
	}
#endif
}

#ifdef SERIAL_DEBUG
extern void debug_putc(uint8_t ch);
extern void debug_puts(char *buf);
extern void debug_put_hex(uint8_t v);
#endif
#endif /* __aspconfig_h_included__ */
